// @Harness: tir-init
// @Test: logical operators
// @Result: PASS

component logical04 {
    field res_01: boolean = op(true, true);
    field res_02: boolean = op(false, false);
    field res_03: boolean = op(true, false);
    field res_04: boolean = op(false, true);

    method op(a: boolean, b: boolean): boolean {
	return a != b; // exclusive-or operation
    }
}

/* 
heap {
    record #0:4:logical04 {
        field res_01: boolean = boolean:false;
        field res_02: boolean = boolean:false;
        field res_03: boolean = boolean:true;
        field res_04: boolean = boolean:true;
    }
} */
