// @Harness: tir-init
// @Test: virtual method invocations
// @Result: PASS

class pv05_a {
    method get(): int { return val; }
    private field val: int = 1;
}

class pv05_b extends pv05_a {
    private field val: boolean = true;
}

class pv05_c extends pv05_a {
    private field val: char = '3';
}

component pv05 {
    field av: int = new pv05_a().get();
    field bv: int = new pv05_b().get();
    field cv: int = new pv05_c().get();
}

/* 
heap {
    record #0:3:pv05 {
        field av: int = int:1;
        field bv: int = int:1;
        field cv: int = int:1;
    }
} */
