// @Harness: virgil-seman
// @Test: virtual method invocations
// @Result: PASS

class inh20_a {
    method get(): function(): int { return this.val; }
    private method val(): int { return 1; }
}

class inh20_b extends inh20_a {
    private method val(): int { return 2; }
}

component inh20 {
    field a: function():int = new inh20_a().get();
    field b: function():int = new inh20_b().get();
    field av: int = a();
    field bv: int = b();
}
