// @Harness: virgil-seman
// @Test: private methods with overridden return type
// @Result: PASS

class pv06_a {
    method get(): function(): int { return val; }
    private method val(): int { return 1; }
}

class pv06_b extends pv06_a {
    private method val(): boolean { return true; }
}

class pv06_c extends pv06_a {
    private method val(): char { return '3'; }
}

component pv06 {
    field a: function():int = new pv06_a().get();
    field b: function():int = new pv06_b().get();
    field c: function():int = new pv06_c().get();
    field av: int = a();
    field bv: int = b();
    field cv: int = c();
}
