// @Harness: tir-to-c
// @Test: logical operators
// @Result: 0=0, 1=7, 2=6, 3=4, 4=4, 5=0

class ander {
    field a: boolean; // true if A() evaluated
    field b: boolean; // true if B() evaluated
    field R: boolean;

    method AND(v1: boolean, v2: boolean) {
	R = A(v1) and B(v2);
    }

    method A(v: boolean): boolean {
	a = true;
	return v;
    }

    method B(v: boolean): boolean {
	b = true;
	return v;
    }
}

component logical06 {
    field a: ander = new ander();

    method main(arg: int): int {
	if ( arg == 1 ) a.AND(true, true);
	if ( arg == 2 ) a.AND(true, false);
	if ( arg == 3 ) a.AND(false, true);
	if ( arg == 4 ) a.AND(false, false);
	return add();
    }

    method add(): int {
	local res = 0;
	if ( a.a ) res += 4;
	if ( a.b ) res += 2;
	if ( a.R ) res += 1;
	return res;
    }

}
