program ADCToLeds {

   components { Main, Mica2, ADC}

   entrypoint main = Main.entry;
   entrypoint adc = ADC.convHandler;

}

component Main {

   method entry() {
      Mica2.setPorts();
      Mica2.startLightSensor();
      ADC.enable();
      ADC.setConvFunc(toLEDS);
      while(true) { 
         ADC.startConv(ADC.ADC1, true);
	 Mica2.sleep();
      }
	//device.ADMUX = 0x0;
	//ADC.startConv(ADC.ADC1, true);	
	//Mica2.sleep();
   }

   method toLEDS(value: 10) {
      if ( value[0] == 0b1 ) Mica2.red.on();
      else Mica2.red.off();

      if ( value[1] == 0b1 ) Mica2.yellow.on();
      else Mica2.yellow.off();

      if ( value[2] == 0b1 ) Mica2.green.on();
      else Mica2.green.off();
   }

}
