#!/bin/bash

TESTS='parser seman types init sched tir2c'

if [ $# -gt 0 ]; then
   TESTS=$*
fi

addTests() {
    FILES=`echo $1`
    if [ -f `echo $FILES | cut -d' ' -f1` ]; then
	export TESTS="$TESTS $FILES"
    fi
}

for d in $TESTS; do
    echo "# Running tests in test/$d..."
    export TESTS=''

    addTests "test/$d/*.v"
    addTests "test/$d/*.tst"

    java5 vpc.test.Main -threads=2 $TESTS
done
