// @Harness: tir-init
// @Test: compile-time constants for primitive types
// @Result: PASS

component char_raw02 {
    field a: boolean = 'a'    == 0x61;
    field b: boolean = 'b'    == 0x62;
    field c: boolean = '\n'   == 0x0a;
    field d: boolean = '\t'   == 0x09;
    field e: boolean = '\b'   == 0x08;
    field f: boolean = '\r'   == 0x0d;
    field g: boolean = '\''   == 0x27;
    field h: boolean = '"'    == 0x22;
    field i: boolean = '\377' == 0xff;
    field j: boolean = '\\'   == 0x5c;
    field k: boolean = ' '    == 0x20;
}

/* 
heap {
    record #0:14:char_raw02 {
        field a: boolean = boolean:true;
        field b: boolean = boolean:true;
        field c: boolean = boolean:true;
        field d: boolean = boolean:true;
        field e: boolean = boolean:true;
        field f: boolean = boolean:true;
        field g: boolean = boolean:true;
        field h: boolean = boolean:true;
        field i: boolean = boolean:true;
        field j: boolean = boolean:true;
        field k: boolean = boolean:true;
    }
} */
