// @Harness: tir-init
// @Test: integers comparison operators
// @Result: PASS

component comp03 {
    field res_01: boolean = op(1, 2);
    field res_02: boolean = op(2, 1);
    field res_03: boolean = op(-1, 1);
    field res_04: boolean = op(-1, 0);
    field res_05: boolean = op(-200, -200);
    field res_06: boolean = op(65535, 65535);
    field res_07: boolean = op(14, 13);
    field res_08: boolean = op(13, 14);
    field res_09: boolean = op(-1255, -255);
    field res_10: boolean = op(1000000, 48576);

    method op(a: int, b: int): boolean {
	return a <= b;
    }
}

/* 
heap {
    record #0:10:comp03 {
        field res_01: boolean = boolean:true;
        field res_02: boolean = boolean:false;
        field res_03: boolean = boolean:true;
        field res_04: boolean = boolean:true;
        field res_05: boolean = boolean:true;
        field res_06: boolean = boolean:true;
        field res_07: boolean = boolean:false;
        field res_08: boolean = boolean:true;
        field res_09: boolean = boolean:true;
        field res_10: boolean = boolean:false;
    }
} */
