// @Harness: tir-init
// @Test: character comparison operators
// @Result: PASS

component comp08 {
    field res_01: boolean = op('a', 'b');
    field res_02: boolean = op('b', 'a');
    field res_03: boolean = op('\n', '1');
    field res_04: boolean = op('\377', '0');
    field res_05: boolean = op('\n', '\n');
    field res_06: boolean = op('\377', '\377');
    field res_07: boolean = op('a', 'A');
    field res_08: boolean = op('A', 'Z');
    field res_09: boolean = op('$', 'z');
    field res_10: boolean = op('z', '~');

    method op(a: char, b: char): boolean {
	return a > b;
    }
}

/* 
heap {
    record #0:10:comp08 {
        field res_01: boolean = boolean:false;
        field res_02: boolean = boolean:true;
        field res_03: boolean = boolean:false;
        field res_04: boolean = boolean:true;
        field res_05: boolean = boolean:false;
        field res_06: boolean = boolean:false;
        field res_07: boolean = boolean:true;
        field res_08: boolean = boolean:false;
        field res_09: boolean = boolean:false;
        field res_10: boolean = boolean:false;
    }
} */
