// @Harness: tir-init
// @Test: virtual method invocations
// @Result: PASS

class dg14_a {
    method val(): int { return 1; }
}

class dg14_b extends dg14_a {
    method val(): int { return 2; }
}

component dg14 {
    field a01: boolean;
    field a02: boolean;
    field a03: boolean;
    field a04: boolean;
    field a05: boolean;
    field a06: boolean;
    field a07: boolean;
    field a08: boolean;
    field a09: boolean;

    constructor() {
        local ao = new dg14_a();
        local bo = new dg14_b();

	local af = ao.val;
	local bf = bo.val;
	local cf = bar;

	a01 = compare(af, ao.val);
	a02 = compare(bf, bo.val);
	a03 = compare(cf, bar);
	a04 = compare(af, bo.val);
	a05 = compare(bf, ao.val);
	a06 = compare(cf, null);
	a07 = compare(af, new dg14_a().val);
	a08 = compare(bf, new dg14_b().val);
	a09 = compare(cf, bar);
    }

    method compare(f: function(): int, g: function(): int): boolean {
	return f == g;
    }

    method bar(): int {
	return 3;
    }
}

/* 
heap {
    record #0:9:dg14 {
	field a01: boolean = boolean:true;
	field a02: boolean = boolean:true;
	field a03: boolean = boolean:true;
	field a04: boolean = boolean:false;
	field a05: boolean = boolean:false;
	field a06: boolean = boolean:false;
	field a07: boolean = boolean:false;
	field a08: boolean = boolean:false;
	field a09: boolean = boolean:true;
    }
} */
