// @Harness: tir-to-c
// @Test: virtual method invocations
// @Result: 0=42, 1=11, 2=21, 3=31, 4=42, 5=11, 6=21, 7=31, 8=42

class delegate03_a {
    field val: int;
    constructor(i: int) { val = i; }
    method get(): delegate03_a { return this; }
}

class delegate03_b extends delegate03_a {
    constructor(i: int) : super(i) { }
}

class delegate03_c extends delegate03_a {
    constructor(i: int) : super(i) { }
}

component delegate03 {
    field a: delegate03_a = new delegate03_a(11);
    field b: delegate03_a = new delegate03_b(21);
    field c: delegate03_a = new delegate03_c(31);
    field am: function():delegate03_a = a.get;
    field bm: function():delegate03_a = b.get;
    field cm: function():delegate03_a = c.get;

    field f42: function():delegate03_a = new delegate03_a(42).get;

    method main(arg: int): int {
	if ( arg == 1 ) return am().val;
	if ( arg == 2 ) return bm().val;
	if ( arg == 3 ) return cm().val;

        local m = f42;
	if ( arg == 5 ) m = a.get;
	if ( arg == 6 ) m = b.get;
	if ( arg == 7 ) m = c.get;

	return m().val;
    }
}
