// @Harness: tir-to-c
// @Test: virtual method invocations
// @Result: 0=42, 1=11, 2=11, 3=11, 4=42

class private02_a {
    method get(): int { return val(); }
    private method val(): int { return 11; }
}

class private02_b extends private02_a {
    private method val(): int { return 21; }
}

class private02_c extends private02_a {
    private method val(): int { return 31; }
}

component private02 {
    field ao: private02_a = new private02_a();
    field bo: private02_a = new private02_b();
    field co: private02_a = new private02_c();

    method main(arg: int): int {
	if ( arg == 1 ) return ao.get();
	if ( arg == 2 ) return bo.get();
	if ( arg == 3 ) return co.get();
	return 42;
    }
}
