// @Harness: tir-to-c
// @Test: arithmetic operators
// @Result: 0=0, 1=1, 2=1, 3=1, 4=1, 5=1, 6=1, 7=1, 8=1, 9=1, 10=0

component raw_shl05 {
    field res_01: 13 = op(0x0f,   1);
    field res_02: 13 = op(0x02,   2);
    field res_03: 13 = op(0x01,  16);
    field res_04: 13 = op(0x30,   8);
    field res_05: 13 = op(0xf0,  13);
    field res_06: 13 = op(0xfff, 12);
    field res_07: 13 = op(0x100, 10);
    field res_08: 13 = op(0xff,   5);
    field res_09: 13 = op(0xaa,   0);

    method op(a: 13, b: int): 13 {
	return a << b;
    }

    method main(arg: int): boolean {
	if ( arg == 1 ) return op(0x0f,   1) == res_01;
	if ( arg == 2 ) return op(0x02,   2) == res_02;
	if ( arg == 3 ) return op(0x01,  16) == res_03;
	if ( arg == 4 ) return op(0x30,   8) == res_04;
	if ( arg == 5 ) return op(0xf0,  13) == res_05;
	if ( arg == 6 ) return op(0xfff, 12) == res_06;
	if ( arg == 7 ) return op(0x100, 10) == res_07;
	if ( arg == 8 ) return op(0xff,   5) == res_08;
	if ( arg == 9 ) return op(0xaa,   0) == res_09;
	return false;
    }
}
