// @Harness: tir-to-c
// @Test: arithmetic operators
// @Result: 0=0, 1=1, 2=1, 3=1, 4=1, 5=1, 6=1, 7=1, 8=1, 9=1, 10=0

component raw_shr03 {
    field res_01: 8 = op(0x0f,  1);
    field res_02: 8 = op(0x02,  2);
    field res_03: 8 = op(0x01,  7);
    field res_04: 8 = op(0x70,  5);
    field res_05: 8 = op(0xf0,  6);
    field res_06: 8 = op(0xff,  2);
    field res_07: 8 = op(0x80, 11);
    field res_08: 8 = op(0xff,  5);
    field res_09: 8 = op(0xaa,  0);

    method op(a: 8, b: int): 8 {
	return a >> b;
    }

    method main(arg: int): boolean {
	if ( arg == 1 )  return op(0x0f,  1) == res_01;
	if ( arg == 2 )  return op(0x02,  2) == res_02;
	if ( arg == 3 )  return op(0x01,  7) == res_03;
	if ( arg == 4 )  return op(0x70,  5) == res_04;
	if ( arg == 5 )  return op(0xf0,  6) == res_05;
	if ( arg == 6 )  return op(0xff,  2) == res_06;
	if ( arg == 7 )  return op(0x80, 11) == res_07;
	if ( arg == 8 )  return op(0xff,  5) == res_08;
	if ( arg == 9 )  return op(0xaa,  0) == res_09;
	return false;
    }
}
