// @Harness: tir-to-c
// @Test: null exceptions
// @Result: 0=42, 1=NullCheckException, 2=13, 3=NullCheckException, 4=42

class rtex_null10_obj {
    method baz(): int { return 13; }
}

component rtex_null10 {
    field a: rtex_null10_obj;
    field b: rtex_null10_obj = new rtex_null10_obj();
    field c: rtex_null10_obj;

    method main(arg: int): int {
	local m = m42;
	if ( arg == 1 ) m = get(a);
	if ( arg == 2 ) m = get(b);
	if ( arg == 3 ) m = get(c);
	return m();
    }

    method m42(): int {
	return 42;
    }

    method get(o: rtex_null10_obj): function(): int {
	return o.baz;
    }
}
