// @Harness: tir-to-c
// @Test: virtual method invocations
// @Result: 0=42, 1=11, 2=11, 3=31, 4=42

class virtual05a_1 {
    method val(): int { return 11; }
}

class virtual05a_2 extends virtual05a_1 {
}

class virtual05a_3 extends virtual05a_2 {
    method val(): int { return 31; }
}

component virtual05a {
    field a: virtual05a_1 = new virtual05a_1();
    field b: virtual05a_1 = new virtual05a_2();
    field c: virtual05a_1 = new virtual05a_3();

    method main(arg: int): int {
	if ( arg == 1 ) return a.val();
	if ( arg == 2 ) return b.val();
	if ( arg == 3 ) return c.val();
	return 42;
    }
}
